POJ-3126 Prime Path[广度优先搜索]

题目

原题在这里
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample

input
3
1033 8179
1373 8017
1033 1033
output
6
7
0

题目大意

题目给出两个素数,要求通过操作来使其中一个素数转换为另一个,要求每次操作只能改变这个数字的一位,且改变过程中的数字都为素数。要求求出最少的改变次数。

大致思路

先将范围内的素数求出,然后通过广度优先搜索即可求出最短的距离。
这里我犯懒用了个素数筛的模版,这里先贴一下吧。

const int MAXN = 1000000;
int prime[MAXN+1];
bool vis[MAXN+1]; //下标为素数的对应的值为flase
int cnt = 0;

void init(int n) {
    vis[0] = vis[1] = true;
    for(int i = 2; i < n; ++i) {
        if(!vis[i])
            prime[cnt++] = i;
        for(int j = 0; j < cnt; ++j) {
            if(1ll*i*prime[j] > n) //1ll用于将数据转化为long long类型
                break;
            vis[i*prime[j]] = true;
            if(i%prime[j] == 0)
                break;
        }
    }
}

AC代码

#include <iostream>
#include <cstring>
#include <queue>
#include <cstdio>

#define FI first
#define SE second
using namespace std;

typedef pair<int, int> PII;

const int MAXN = 10005;
int prime[MAXN+1];
bool vis[MAXN+1]; //下标为素数的对应的值为flase
int cnt = 0;
bool isvis[MAXN];

void init(int n) {
    vis[0] = vis[1] = true;
    for(int i = 2; i < n; ++i) {
        if(!vis[i])
            prime[cnt++] = i;
        for(int j = 0; j < cnt; ++j) {
            if(1ll*i*prime[j] > n) //1ll用于将数据转化为long long类型
                break;
            vis[i*prime[j]] = true;
            if(i%prime[j] == 0)
                break;
        }
    }
}
inline int change(int n, int x, int y) {  // 将数字n的第x位变为y
    int mod = 1;
    for(int i = 0; i < x; ++i)
        mod *= 10;
    int low = n%mod;
    int high = n/(mod*10);
    high = high*10 + y;
    return high*mod+low;
}
int bfs(int a, int b) {
    memset(isvis, 0, sizeof(isvis));
    queue<PII> que;
    que.push({a, 0});
    while(que.size()) {
        PII t = que.front(); que.pop();
        if(t.FI == b) return t.SE;
        for(int i = 0; i < 4; ++i) {
            for(int j = 0; j < 10; ++j) {
                int n = change(t.FI, i, j);
                if(!vis[n] && n >= 1000 && !isvis[n]) {
                    /* printf("%d change to %d by change the %dth number to %d\n", */
                    /*         t.FI, n, i, j); */
                    que.push({n, t.SE+1});
                    isvis[n] = true;
                }
            }
        }
    }
    return -1;
}

int main(void)
{
    init(MAXN);
    int N, a, b;
    scanf("%d", &N);
    while(N--) {
        scanf("%d%d", &a, &b);
        int flag = bfs(a, b);
        if(flag < 0)
            puts("Impossible");
        else printf("%d\n", flag);
    }
    return 0;
}

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 2
    评论
评论 2
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值